import rox
try:
	from urlgrabber import byterange
except:
	url = 'http://linux.duke.edu/projects/urlgrabber/'
	rox.alert('ROXget requires the urlgrabber package\n\n%s' % url)

import sys, urllib2, urlparse, datetime, gtk

import options
from support import *

RUNNING = -1
UNKNOWN_ERROR = 0
SUCCESSFUL = 1
ABORTED = 2
INCOMPLETE = 3

SIZE_UNKNOWN = -1

class Downloader(object):
	def __init__(self,url=None):
		self.time = datetime.datetime(1,1,1)
		self.valid = None
		self.status = None
		self.url = url
		self.start = 0
		self.resume = False
		
	def build_openchain(self):
		handlers = []
		proxy = self.build_proxy()
		if proxy:
			handlers.append(proxy)
		handlers.append(urllib2.HTTPRedirectHandler)
		handlers.append(byterange.HTTPRangeHandler)
		handlers.append(urllib2.HTTPSHandler)
		handlers.append(byterange.FTPRangeHandler)
		opener = urllib2.build_opener(*handlers)
		urllib2.install_opener(opener)
		
	def build_proxy(self):
		proxy_str = ''
		if options.proxy_host.value:
			if options.proxy_user.value:
				if options.proxy_pass.value:
					proxy_str = ':' + options.proxy_pass.value
				proxy_str = options.proxy_user.value + proxy_str + '@'
			host = options.proxy_host.value
			port = str(options.proxy_port.int_value)
			proxy_str = 'http://' + proxy_str + host + ':' + port
			
			proxies = {}
			if options.proxy_http.int_value:
				proxies['http'] = proxy_str
			if options.proxy_https.int_value:
				proxies['https'] = proxy_str
			if options.proxy_ftp.int_value:
				proxies['ftp'] = proxy_str
			if proxies:
				return urllib2.ProxyHandler(proxies)
				
	def validate(self):
		self.build_openchain()
		try:
			fp = urllib2.urlopen(self.url)
			self.url = fp.geturl()
			self.valid = True
		except ValueError, e:
			self.valid = str(e)
		except urllib2.URLError, e:
			self.valid = str(e)
		except urllib2.HTTPError, e:
			self.valid = str(e)
	
	def resume_from(self,start):
		self.build_openchain()
		size = self.fp.headers['content-length']
		header = {'Range':'bytes=%s-%s'%(str(start),size)}
		req = urllib2.Request(self.url,headers=header)
		try:
			self.fp = urllib2.urlopen(req)
			self.resume = True
			self.start = start
			return True
		except:
			self.resume = False
			return False
		
	def write(self,stream,callback=None):
		self.status = RUNNING
		if not self.resume:
			self.build_openchain()
			self.fp = urllib2.urlopen(self.url)
		print self.fp
		self.time = self.time.today()
		self.time
		self.size = int(self.fp.headers['content-length'])
		self.count = 0
		self.aborted = False
		data = 1
		while data:
			if self.aborted:
				self.status = ABORTED
				self.fp.close()
				return
			try:
				data = self.fp.read(options.bufsize.int_value)
				stream.write(data)
				self.count += len(data)
				if callback:
					url_data = (self.url,self.fp.headers)
					byte_data = (self.start,self.size,self.count)
					time_data = (self.time, self.time.today())
					callback(url_data,byte_data,time_data)
			except Exception, e:
				rox.report_exception()
				self.status = UNKNOWN_ERROR
				self.fp.close()
				return
		self.fp.close()
		if self.size == SIZE_UNKNOWN or self.count == self.size:
			self.status = SUCCESSFUL
		else:
			self.status = INCOMPLETE
		
	def abort(self):
		print "ABORT"
		self.aborted = True
		